%% Code for Day 8
% Add path to EEGLab and launch EEGLab before we begin (or use your
% shortcut on the shortcuts bar)



%% PCA and ICA, Eigen Vectors and Eigen Values
% ----------------------------------------------------------
    edit PCA_ICA_dipole.m

%% Connectivity 
% ----------------------------------------------------------
    edit phase_connectivity.m

%% Updated and Expanded Integration and comparison ASSIGNMENT
% Integration of TF-Power and ITPC, and ISPC and 
% ----------------------------------------------------------

    % If you need some hints, see itpc.m from Day 7 code

    %% Choose some parameters
    
    % Using the Sample Data, 
        load '../Day07/ERN_Data_LM_Ref.mat';  % provided with Day07 download, but change as needed

    % explore the time and topography to choose a channel to focus on
        pop_topoplot(EEG,1, [50:50:800] ,'EEG sample dataset',[4 4] ,0,'electrodes','on');
        
    % choose a site 
        channel2use = 'FCz';  
        chan2use_idx = strcmpi(channel2use,{EEG.chanlocs.labels});
        
    % times to plot (avoid edge effects)
        times2plot = [-100 800]; % or choose your own
        times2plot_idx = dsearchn(EEG.times',times2plot')';
        times2plot_idx = times2plot_idx(1):times2plot_idx(2);
        
    % Using the ERN sample data at this site                                
        % compute the time-frequency power  and ITPC on the raw data
        
        % wavelet parameters
            num_frex = ##;
            min_freq = #;
            max_freq = ##;
        % set range for variable number of wavelet cycles
            range_cycles = [ 4 10 ];

        % more wavelet parameters
            frex = logspace(#,#,#);
            wavecycles = logspace(log10(range_cycles(1)),log10(range_cycles(end)),num_frex);
            time = -2:1/EEG.srate:2;
            half_wave_size = (length(time)-1)/2;

        % FFT parameters
            nWave = length(time);
            nData = EEG.pnts*EEG.trials;
            nConv = nWave+nData-1;

    %% time-frequency decomposition
        % FFT of data (doesn't change on frequency iteration)
            dataX = fft( reshape(EEG.data(chan2use_idx,:,:),1,nData) ,nConv);

        % initialize output time-frequency data
            tf = zeros(num_frex,EEG.pnts,EEG.trials);
            tf_power = zeros(num_frex,EEG.pnts);
            tf_phase = zeros(num_frex,EEG.pnts);

        % loop over frequencies
        for fi=1:num_frex

            % create wavelet and get its FFT
            s = wavecycles(fi)/(2*pi*frex(fi));
            wavelet  = exp(2*1i*pi*frex(fi).*time) .* exp(-time.^2./(2*s^2));
            waveletX = fft(wavelet,nConv);

            % run convolution
            as = ifft(waveletX.*dataX,nConv);
            as = as(half_wave_size+1:end-half_wave_size);
            as = reshape(as,EEG.pnts,EEG.trials);

            % put this into the tf matrix of complex numbers
            tf(fi,:,:) =#;
        end
        
        
        % compute ITPC  (it's the absolute length of the mean Eulerized phase
            % angle across trials: abs, mean, euler, angle)
              % For each frequency, this will be a time-series of ITPC values 
            tf_phase= #(#(exp(1i*#(tf)),#));
            
        % computer power at each freq and time (it's the mean of the length
            % of the complex vector (squared for power)
            % mean across trials, abs, dot-squared
            tf_power= #(#(tf).^2,#);
            
        % baseline correct the data using db-correction
            baseline_window = [ -100 0] ; % in msec -- choose your own!
        % convert baseline time into indices
            baseidx = dsearchn(EEG.times',baseline_window')';
            baseline = mean( tf_power(:,baseidx(1):baseidx(2)) ,#);
        % decibel correction
            tf_power = 10*log10(bsxfun(@rdivide, tf_power, #) );

%%  Plotting  
        % Plot a 1 x 2 set of subpots with power, ITPC, but place it in a
        % 3x2 grid of subplots (as the first row of this bigger grid)    
        % Plot a 1 x 2 set of subpots with power, ITPC, but place it in a
        % 3x2 grid of subplots
            
            % hint: contourf(EEG.times(times2plot_idx),frex,tf_power(:,times2plot_idx),40,'linecolor','none');

    %% ASSIGNMENT: Do the same for a second site        
        % Do this again for a second site
        % save the AS data in a different variable for later phase angle
        % diffs calculations
        
        % Plot in the second row of subpllots (power, ITPC)
        
    %% ASSIGNMENT: Now get ISPC bewtween the two sites, 
    %   and calculate ISPC Value and (BONUS) PLI Value
        % need to get phase angle differences
        
        % plot ISPC in the 6th subplot and include title to show ISPC value
        % (and PLI if you feel BONUSy and plot in 5th subplot)

    %% ASSIGNMENT:  Now redo all the above for laplacian-transformed data, 
    % and plot in a new figure so you can compare voltage to CSD data
    

    
        
